﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Net.Sockets;


namespace tcp_test
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    /// 

    public partial class MainWindow : Window
    {
        private int Opened;
        private System.Net.Sockets.TcpClient m_TcpClient;           // TCPクライアント
        private System.Net.Sockets.NetworkStream m_NetworkStream;   // ネットワークストリーム

        public MainWindow()
        {
            InitializeComponent();
            Opened = 0;
            btnOpen_Close.Content  = "OPEN";
            txtSendMsg.Text  = "*idn?";
            btnRead.IsEnabled = false;
            btnSend.IsEnabled = false;
            txtSocket.IsEnabled = true;
            txtIPAddress.IsEnabled = true;
        }

        private void btnOpen_Close_click(object sender, RoutedEventArgs e)
        {
            if (btnOpen_Close.Content.ToString() == "OPEN" )
            {
                try
                {
                    // Device Open and Init
                    this.m_TcpClient = new System.Net.Sockets.TcpClient();
                    this.m_TcpClient.Connect(txtIPAddress.Text, int.Parse(txtSocket.Text));
                    this.m_NetworkStream = this.m_TcpClient.GetStream();

                    // Set form
                    btnOpen_Close.Content  = "CLOSE";
                    btnRead.IsEnabled = true;
                    btnSend.IsEnabled = true;
                    txtSocket.IsEnabled = false;
                    txtIPAddress.IsEnabled = false;
                    Opened = 1;
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                    this.m_NetworkStream = null;
                    this.m_TcpClient = null;
                }
                finally
                {
                    ;
                }
            }
            else
            {
                if (this.m_TcpClient != null && this.m_TcpClient.Connected == true)
                {
                    this.m_NetworkStream.Close();
                    this.m_TcpClient.Close();
                }
                this.m_NetworkStream = null;
                this.m_TcpClient = null;
                Opened = 0;
                btnOpen_Close.Content = "OPEN";
                txtSendMsg.Text = "*idn?";
                btnRead.IsEnabled = false;
                btnSend.IsEnabled = false;
                txtSocket.IsEnabled = true;
                txtIPAddress.IsEnabled = true;
                txtReadMsg.Text = "";
            }
        }

        private void btnSend_Click(object sender, RoutedEventArgs e)
        {
            string SendMsg;

            SendMsg = txtSendMsg.Text + "\n";
            try
            {
                WriteLine(SendMsg);
                if (SendMsg.IndexOf("?") >= 0)
                {
                    System.Threading.Thread.Sleep(200);
                    btn_Read();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btnRead_Click(object sender, RoutedEventArgs e)
        {
            btn_Read();
        }

        private void FormClosing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            // Device Close
            if (Opened != 0)
            {
                if (this.m_TcpClient != null && this.m_TcpClient.Connected == true)
                {
                    this.m_NetworkStream.Close();
                    this.m_TcpClient.Close();
                }
                this.m_NetworkStream = null;
                this.m_TcpClient = null;
            }
        }
        private void btn_Read()
        {
            try
            {
                txtReadMsg.Text = Readbuff() + "\r\n";
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                ;
            }
        }
        private void WriteLine(string sendMsg)
        {
            byte[] SendBuff = System.Text.Encoding.GetEncoding("utf-8").GetBytes(sendMsg);
            m_NetworkStream.Write(SendBuff, 0, SendBuff.Length);
            m_NetworkStream.Flush();
        }
        private string Readbuff()
        {
            byte[] reciveBufff = new byte[256];

            int DataCnt = this.m_TcpClient.Available;
            if (DataCnt > 255) DataCnt = 255;
            m_NetworkStream.Read(reciveBufff, 0, DataCnt);
            return System.Text.Encoding.GetEncoding("utf-8").GetString(reciveBufff).Substring(0, DataCnt);
        }

    }
}
